## ros-one-control-toolbox 1.18.2-9jammy.20260221.0027

=== debian/changelog ===
ros-one-control-toolbox (1.18.2-9jammy.20260221.0027) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 21 Feb 2026 00:27:27 +0000

ros-one-control-toolbox (1.18.2-0jammy) jammy; urgency=high

  * Python 3 compat part II
  * Contributors: Tobias Fischer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 04 Jun 2020 00:00:00 -0000

ros-one-control-toolbox (1.18.1-0jammy) jammy; urgency=high

  * Python 3 compat
  * Migrate to new industrial_ci
  * Contributors: Matt Reynolds, Tobias Fischer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 01 Jun 2020 00:00:00 -0000

ros-one-control-toolbox (1.18.0-0jammy) jammy; urgency=high

  * Bump CMake version to avoid CMP0048 warning
  * add static method to generate non-deterministic seed
  * migrate to STL random library
  * Contributors: James Xu, Shane Loretz, ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Mar 2020 00:00:00 -0000

ros-one-control-toolbox (1.17.0-0jammy) jammy; urgency=high

  * update anti windup clamping
  * update negativeIntegrationAntiwindupTest
  * Address catkin_lint issues
  * Add executable flag
  * convert to package xml format 2
  * Remove doc header
  * Contributors: Bence Magyar, Cong, Gennaro Raiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 31 Jan 2019 00:00:00 -0000

ros-one-control-toolbox (1.16.0-0jammy) jammy; urgency=high

  * switched to industrial_ci
  * Add control_msgs to CATKIN_DEPENDS.
  * Contributors: Bence Magyar, Mathias Luedtke, Mike Purvis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Nov 2017 00:00:00 -0000

ros-one-control-toolbox (1.15.0-0jammy) jammy; urgency=high

  * avoid ABI breaks in PID class
  * fix add_dependencies call
  * rollback API changes in PID class
  * cfg: removed rosbuild support related error handling
  * Contributors: Bence Magyar, Igor Napolskikh, ipa-mig

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 28 Jun 2016 00:00:00 -0000

ros-one-control-toolbox (1.14.0-0jammy) jammy; urgency=high

  * Fix negative gains issue and add tests; update gains setting through DynamicReconfig
  * Add antiwindup and tests to PID controller; rename old behaviour 'clamping'
  * Move message to control_toolbox
  * Add optional state publishing to PID controller, for logging/debugging/etc
  * Fix some typos in comments
  * changed the range of dynamic reconfigure to allow negative ones
  * Address -Wunused-parameter warnings
  * Factor out updatePid as negative calls to computeCommand
  * Increasing covergae of PID class test suite.
  * Chain calls of computeCommand and updatePid for code reuse
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Bence Magyar, Carlos Rosales, Guillaume Walck, Paul Bovbel, VahidAminZ

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 03 May 2016 00:00:00 -0000

ros-one-control-toolbox (1.13.2-0jammy) jammy; urgency=high

  * CRITICAL BUGFIX: Fix broken PID command computation.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Paul Bovbel

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 22 May 2015 00:00:00 -0000

ros-one-control-toolbox (1.13.1-0jammy) jammy; urgency=high

  * Improvement in integral contribution implementation. Resolve #32 <https://github.com/ros-controls/control_toolbox/issues/32>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Carlos Rosales

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Apr 2015 00:00:00 -0000

ros-one-control-toolbox (1.13.0-0jammy) jammy; urgency=high

  * Harmonize pid gain names between rosparam and dynamic_reconfigure
  * Read i_clamp_min and i_clamp_max form parameter server - if available
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, ipa-fxm

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-one-control-toolbox (1.12.1-0jammy) jammy; urgency=high

  * Remove broken test code. Hotfix for #18 <https://github.com/ros-controls/control_toolbox/issues/18>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 12 Jun 2014 00:00:00 -0000

ros-one-control-toolbox (1.12.0-0jammy) jammy; urgency=high

  * pid: Adding quiet flag to suppress error message
  * Contributors: Jonathan Bohren

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 12 Jun 2014 00:00:00 -0000

ros-one-control-toolbox (1.11.0-0jammy) jammy; urgency=high

  * Remove rosbuild artifacts
  * Cleaned up CMake and removed unnecessary dependencies
  * Made default value negative to match valid range
  * Fix for i_clamp_min to be negative in dynamic reconfigure
  * Fix abs/fabs problem with Clang and libc++
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, Marco Esposito

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 12 May 2014 00:00:00 -0000

ros-one-control-toolbox (1.10.4-0jammy) jammy; urgency=high

  * Added Travis support
  * Renamed manifest.xml so it doesn't break rosdep
  * Expanded range of PID and windup gains for certain applications.
  * Expanded range of PID and windup gains for certain applications. Lowered default integral and derivative gain
  * check for CATKIN_ENABLE_TESTING
  * Add some comments to Parameters.cfg
  * Add support for dynamic_reconfigure for rosbuild
  * Contributors: Austin Hendrix, Dave Coleman, Lukas Bulwahn, Paul Dinh

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-one-control-toolbox (1.10.3-0jammy) jammy; urgency=high

  * Fix bug in copy constructor.
  * Contributors: Austin Hendrix

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 02 Aug 2013 00:00:00 -0000

ros-one-control-toolbox (1.10.2-0jammy) jammy; urgency=high

  * Fix copy constructor.
  * Merge pull request #1 <https://github.com/ros-controls/control_toolbox/issues/1> from davetcoleman/hydro-devel
    Added dynamic reconfigure for PID gains
  * Removed const getGains function


## ros-one-control-toolbox 1.18.2-9noble.20251023.0346

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(control_toolbox)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS
  cmake_modules
  control_msgs
  dynamic_reconfigure
  message_generation
  realtime_tools
  roscpp
  std_msgs
  )

find_package(Boost REQUIRED COMPONENTS system thread)
find_package(TinyXML REQUIRED)

# Dynamics reconfigure
generate_dynamic_reconfigure_options(
  cfg/Parameters.cfg
  )

# Add services and generate them
add_service_files(
  FILES
  SetPidGains.srv
  )

generate_messages(
  DEPENDENCIES std_msgs
)

# Declare catkin package
catkin_package(
  DEPENDS TinyXML
  CATKIN_DEPENDS
    control_msgs
    dynamic_reconfigure
    message_runtime
    realtime_tools
    roscpp
    std_msgs
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  )

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIR}
  ${TinyXML_INCLUDE_DIRS}
  )

add_library(${PROJECT_NAME}
  src/dither.cpp
  src/limited_proxy.cpp
  src/pid.cpp
  src/pid_gains_setter.cpp
  src/sine_sweep.cpp
  src/sinusoid.cpp
  )
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

target_link_libraries(${PROJECT_NAME} ${TinyXML_LIBRARIES} ${catkin_LIBRARIES} ${Boost_LIBRARIES})

if(CATKIN_ENABLE_TESTING)
  # Tests
  catkin_add_gtest(pid_tests test/pid_tests.cpp)
  target_link_libraries(pid_tests ${catkin_LIBRARIES} ${PROJECT_NAME})

  # add_executable(test_linear test/linear.cpp)
endif()

# Install
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

# Install library
install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
  )

install(DIRECTORY scripts/
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

=== debian/changelog ===
ros-one-control-toolbox (1.18.2-9noble.20251023.0346) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Oct 2025 03:46:29 +0000

ros-one-control-toolbox (1.18.2-0noble) noble; urgency=high

  * Python 3 compat part II
  * Contributors: Tobias Fischer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 04 Jun 2020 00:00:00 -0000

ros-one-control-toolbox (1.18.1-0noble) noble; urgency=high

  * Python 3 compat
  * Migrate to new industrial_ci
  * Contributors: Matt Reynolds, Tobias Fischer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 01 Jun 2020 00:00:00 -0000

ros-one-control-toolbox (1.18.0-0noble) noble; urgency=high

  * Bump CMake version to avoid CMP0048 warning
  * add static method to generate non-deterministic seed
  * migrate to STL random library
  * Contributors: James Xu, Shane Loretz, ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Mar 2020 00:00:00 -0000

ros-one-control-toolbox (1.17.0-0noble) noble; urgency=high

  * update anti windup clamping
  * update negativeIntegrationAntiwindupTest
  * Address catkin_lint issues
  * Add executable flag
  * convert to package xml format 2
  * Remove doc header
  * Contributors: Bence Magyar, Cong, Gennaro Raiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 31 Jan 2019 00:00:00 -0000

ros-one-control-toolbox (1.16.0-0noble) noble; urgency=high

  * switched to industrial_ci
  * Add control_msgs to CATKIN_DEPENDS.
  * Contributors: Bence Magyar, Mathias Luedtke, Mike Purvis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Nov 2017 00:00:00 -0000

ros-one-control-toolbox (1.15.0-0noble) noble; urgency=high

  * avoid ABI breaks in PID class
  * fix add_dependencies call
  * rollback API changes in PID class
  * cfg: removed rosbuild support related error handling
  * Contributors: Bence Magyar, Igor Napolskikh, ipa-mig

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 28 Jun 2016 00:00:00 -0000

ros-one-control-toolbox (1.14.0-0noble) noble; urgency=high

  * Fix negative gains issue and add tests; update gains setting through DynamicReconfig
  * Add antiwindup and tests to PID controller; rename old behaviour 'clamping'
  * Move message to control_toolbox
  * Add optional state publishing to PID controller, for logging/debugging/etc
  * Fix some typos in comments
  * changed the range of dynamic reconfigure to allow negative ones
  * Address -Wunused-parameter warnings
  * Factor out updatePid as negative calls to computeCommand
  * Increasing covergae of PID class test suite.
  * Chain calls of computeCommand and updatePid for code reuse
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Bence Magyar, Carlos Rosales, Guillaume Walck, Paul Bovbel, VahidAminZ

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 03 May 2016 00:00:00 -0000

ros-one-control-toolbox (1.13.2-0noble) noble; urgency=high

  * CRITICAL BUGFIX: Fix broken PID command computation.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Paul Bovbel

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 22 May 2015 00:00:00 -0000

ros-one-control-toolbox (1.13.1-0noble) noble; urgency=high

  * Improvement in integral contribution implementation. Resolve #32 <https://github.com/ros-controls/control_toolbox/issues/32>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Carlos Rosales

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Apr 2015 00:00:00 -0000

ros-one-control-toolbox (1.13.0-0noble) noble; urgency=high

  * Harmonize pid gain names between rosparam and dynamic_reconfigure
  * Read i_clamp_min and i_clamp_max form parameter server - if available
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, ipa-fxm

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-one-control-toolbox (1.12.1-0noble) noble; urgency=high

  * Remove broken test code. Hotfix for #18 <https://github.com/ros-controls/control_toolbox/issues/18>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 12 Jun 2014 00:00:00 -0000

ros-one-control-toolbox (1.12.0-0noble) noble; urgency=high

  * pid: Adding quiet flag to suppress error message
  * Contributors: Jonathan Bohren

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 12 Jun 2014 00:00:00 -0000

ros-one-control-toolbox (1.11.0-0noble) noble; urgency=high

  * Remove rosbuild artifacts
  * Cleaned up CMake and removed unnecessary dependencies
  * Made default value negative to match valid range
  * Fix for i_clamp_min to be negative in dynamic reconfigure
  * Fix abs/fabs problem with Clang and libc++
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, Marco Esposito

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 12 May 2014 00:00:00 -0000

ros-one-control-toolbox (1.10.4-0noble) noble; urgency=high

  * Added Travis support
  * Renamed manifest.xml so it doesn't break rosdep
  * Expanded range of PID and windup gains for certain applications.
  * Expanded range of PID and windup gains for certain applications. Lowered default integral and derivative gain
  * check for CATKIN_ENABLE_TESTING
  * Add some comments to Parameters.cfg
  * Add support for dynamic_reconfigure for rosbuild
  * Contributors: Austin Hendrix, Dave Coleman, Lukas Bulwahn, Paul Dinh

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-one-control-toolbox (1.10.3-0noble) noble; urgency=high

  * Fix bug in copy constructor.
  * Contributors: Austin Hendrix

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 02 Aug 2013 00:00:00 -0000

ros-one-control-toolbox (1.10.2-0noble) noble; urgency=high

  * Fix copy constructor.
  * Merge pull request #1 <https://github.com/ros-controls/control_toolbox/issues/1> from davetcoleman/hydro-devel
    Added dynamic reconfigure for PID gains
  * Removed const getGains function


=== debian/control ===
Source: ros-one-control-toolbox
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libtinyxml-dev, ros-one-catkin (>= 0.5.68), ros-one-cmake-modules, ros-one-control-msgs, ros-one-dynamic-reconfigure, ros-one-message-generation, ros-one-realtime-tools, ros-one-roscpp, ros-one-std-msgs
Homepage: http://ros.org/wiki/control_toolbox
Standards-Version: 3.9.2

Package: ros-one-control-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtinyxml-dev, ros-one-control-msgs, ros-one-dynamic-reconfigure, ros-one-message-runtime, ros-one-realtime-tools, ros-one-roscpp, ros-one-std-msgs
Description: The control toolbox contains modules that are useful across all controllers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-control-toolbox//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-control-toolbox 1.18.2-9noble.20260221.0056

=== debian/changelog ===
ros-one-control-toolbox (1.18.2-9noble.20260221.0056) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 21 Feb 2026 00:56:34 +0000
